summaryrefslogtreecommitdiff
path: root/.local/src/st/external-pipe_scripts/st-copyout
diff options
context:
space:
mode:
Diffstat (limited to '.local/src/st/external-pipe_scripts/st-copyout')
-rwxr-xr-x.local/src/st/external-pipe_scripts/st-copyout16
1 files changed, 16 insertions, 0 deletions
diff --git a/.local/src/st/external-pipe_scripts/st-copyout b/.local/src/st/external-pipe_scripts/st-copyout
new file mode 100755
index 0000000..e7be21e
--- /dev/null
+++ b/.local/src/st/external-pipe_scripts/st-copyout
@@ -0,0 +1,16 @@
+#!/bin/sh
+# Using external pipe with st, give a dmenu prompt of recent commands,
+# allowing the user to copy the output of one.
+# xclip required for this script.
+# By Jaywalker and Luke
+## figure how to not print ps1 without having to clear terminal
+## have only one command in active window and then piping into awk
+## to skip the first line
+tmpfile=$(mktemp /tmp/st-cmd-output.XXXXXX)
+trap 'rm "$tmpfile"' 0 1 15
+sed -n "w $tmpfile"
+sed -i 's/\x0//g' "$tmpfile"
+ps1="$(grep "\S" "$tmpfile" | tail -n 1 | sed 's/^\s*//' | cut -d' ' -f1)"
+chosen="$(grep -F "$ps1" "$tmpfile" | sed '$ d' | tac | dmenu -p "Copy which command's output?" -i -l 10 | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+eps1="$(echo "$ps1" | sed 's/[^^]/[&]/g; s/\^/\\^/g')"
+awk "/^$chosen$/{p=1;print;next} p&&/$eps1/{p=0};p" "$tmpfile" | awk 'NR!=1' |xclip -selection clipboard